/*!
  \file
  \brief 位置

  \author Satofumi Kamimura
*/

#include "PointF.h"

using namespace hrk;


PointF::PointF(void) : x_(0), y_(0)
{
}


PointF::PointF(double x, double y) : x_(x), y_(y)
{
}


double PointF::x(void) const
{
    return x_;
}


double PointF::y(void) const
{
    return y_;
}


void PointF::set_x(double x)
{
    x_ = x;
}


void PointF::set_y(double y)
{
    y_ = y;
}


bool PointF::operator == (const PointF& rhs) const
{
    return ((x_ == rhs.x_) && (y_ == rhs.y_)) ? true : false;
}


bool PointF::operator < (const PointF& rhs) const
{
    if (y_ < rhs.y_) {
        return true;

    } else if (x_ < rhs.x_) {
        return true;

    } else {
        return false;
    }
}


PointF& PointF::operator += (const PointF& rhs)
{
    this->x_ += rhs.x_;
    this->y_ += rhs.y_;

    return *this;
}


const PointF PointF::operator + (const PointF& rhs) const
{
    return PointF(*this) += rhs;
}


PointF& PointF::operator -= (const PointF& rhs)
{
    this->x_ -= rhs.x_;
    this->y_ -= rhs.y_;

    return *this;
}


const PointF PointF::operator - (const PointF& rhs) const
{
    return PointF(*this) -= rhs;
}


PointF& PointF::operator *= (const double rhs)
{
    this->x_ *= rhs;
    this->y_ *= rhs;

    return *this;
}


const PointF PointF::operator * (const double rhs)
{
    return PointF(*this) *= rhs;
}
