﻿/*!
  \file
  \brief 幅と高さの管理

  \author Satofumi Kamimura
*/

#include "SizeF.h"

using namespace hrk;


SizeF::SizeF(void) : width_(0), height_(0)
{
}


SizeF::SizeF(double width, double height)
    : width_(width), height_(height)
{
}


double SizeF::width(void) const
{
    return width_;
}


double SizeF::height(void) const
{
    return height_;
}


void SizeF::set_width(double width)
{
    width_ = width;
}


void SizeF::set_height(double height)
{
    height_ = height;
}


SizeF& SizeF::operator += (const SizeF& rhs)
{
    this->width_ += rhs.width_;
    this->height_ += rhs.height_;

    return *this;
}


const SizeF SizeF::operator + (const SizeF& rhs) const
{
    return SizeF(*this) += rhs;
}


SizeF& SizeF::operator -= (const SizeF& rhs)
{
    this->width_ -= rhs.width_;
    this->height_ -= rhs.height_;

    return *this;
}


const SizeF SizeF::operator - (const SizeF& rhs) const
{
    return SizeF(*this) -= rhs;
}


SizeF& SizeF::operator *= (double rhs)
{
    width_ *= rhs;
    height_ *= rhs;
    return *this;
}


SizeF SizeF::operator * (double rhs)
{
    return SizeF(width_, height_) *= rhs;
}
