/*!
  \file
  \brief URG のデータ表示アプリケーション

  \author Satofumi Kamimura
*/

#include <QApplication>
#include <QTranslator>
#include "Lidar_viewer_window.h"

using namespace std;


int main(int argc, char *argv[])
{
    QApplication app(argc, argv);

    // ロケールの適用
    QString locale = QLocale::system().name();
    QTranslator translator;
    translator.load("Lidar_viewer_" + locale);
    app.installTranslator(&translator);

    // センサ、再生するファイルの取得
    string sensor_type = "URG";
    string play_file;
    for (int i = 1; i < argc; ++i) {
        const string token = argv[i];
        if ((token == "-lms") || (token == "--lms")) {
            sensor_type = "LMS";
        } else {
            play_file = token;
        }
    }
    Lidar_viewer_window window(sensor_type);
    if (!play_file.empty()) {
        window.load_play_file(play_file);
    }
    window.show();

    return app.exec();
}
